#include "stdafx.h"
#include "common_scan_xml.h"

/*************************************************************************************************************

XMLf[^̃L[Ƀ}b`ubNCӂ̒li[

	pData		Xgf[^̃|C^
	pKEY		L[̃|C^
	iKEYbit		L[̌`ԁi 0,32=32bitCRC / 1=16bitCRC / 100=FileName(body) / 101=FileName(body.ext) j
	pBuf		i[̃|C^
	iSize		i[obt@̃TCY
				0 ͕Kvȃobt@TCYԂis܂ށj

	getTagName	l̃^OOi<></>͕tȂƁBSđ啶Ŏw肷邱ƁBj

	keyTagName	XMLŁAL[͂ł^O̖Oi<></>͕tȂƁBSđ啶Ŏw肷邱ƁBj
	blockTopTag	Q[ubN̐擪^Oi<>t邱ƁBSđ啶Ŏw肷邱ƁBj

	* 1C̉sR[hI[ \n O

*************************************************************************************************************/
int GetText( LPCTSTR &pData, LPCTSTR &pKEY, int iKEYbit, LPSTR &pBuf, int iSize,
			std::string getTagName, std::string keyTagName, std::string blockTopTag )
{
	using namespace std;
	string dat  = (LPCSTR) pData;
	string datU = (LPCSTR) pData;
	string key  = (LPCSTR) pKEY;
	string key2 = (LPCSTR) pKEY;
	string strRes;
	string::size_type idx;
	string::size_type edx;
	string beginTag = "<"+  getTagName +">";
	string endTag   = "</"+ getTagName +">";

	//pɑ啶
	transform( datU.begin(), datU.end(), datU.begin(), toupper );
	transform( key.begin(),  key.end(),  key.begin(),  toupper );
	transform( key2.begin(), key2.end(), key2.begin(), toupper );

	//UTF-8w茟
	string encchkBuf = datU.substr( 0, datU.find( "?>" ) );	//擪 ?> ܂ł "UTF-8" w肪邩`FbN
	string::size_type utf8Flg = encchkBuf.find( "UTF-8" );

	//L[̐`
	switch (iKEYbit){
	case 0:
	case 32:
		while( key.length() < 8 ) key = "0" + key;
		break;
	case 1:
		while( key.length() < 4 ) key = "0" + key;
		break;
	}
	key = ">"+ key  +"</"+ keyTagName +">";	// ex) ">00123ABC</ROMCRC>" = 1,194,684
	key = ">"+ key2 +"</"+ keyTagName +">";	// ex) ">123ABC</ROMCRC>"   = 1,194,684

	//f[^L[
	idx = datU.find( key );
	if( idx == string::npos ) idx = datU.find( key2 );
	if( idx == string::npos ) return ERR_CRCNotFound * -1;

	//ubN̐擪փ|WVړij
	idx = datU.rfind( blockTopTag, idx );
	if( idx == string::npos ) return ERR_ListNA * -1;

	//ړI̕擾
	idx = datU.find( beginTag, idx );	//Jn^O
	if( idx == string::npos ){
		return ERR_ListNA * -1;
	} else {
		idx += beginTag.length() + 1;
		edx = datU.find( endTag, idx );	//I^O
		if( edx == string::npos ) {
			return ERR_ListNA * -1;
		} else {
			idx --;
		}
	}

	//擾
	strRes = dat.substr( idx, edx-idx );

	//UTF-8ȂSJISɕϊ
	if( utf8Flg != string::npos ){
		//UTF-8Unicodeɕϊ
		int uLen = MultiByteToWideChar( CP_UTF8, 0, (LPCSTR)strRes.c_str(), -1, 0, 0 );
		LPWSTR ucBuf = (LPWSTR)calloc( ( uLen * 2 + 10 ), sizeof(int) );
		MultiByteToWideChar( CP_UTF8, 0, (LPCSTR)strRes.c_str(), -1, ucBuf, uLen );
		//UnicodeShift-JISɕϊ
		uLen = WideCharToMultiByte( CP_ACP, 0, ucBuf, -1, 0, 0,  NULL, NULL );
		LPSTR utf8Buf = (LPSTR)calloc( ( uLen + 10 ), sizeof(int) );
		WideCharToMultiByte( CP_ACP, 0, ucBuf, -1, utf8Buf, uLen,  NULL, NULL);
		strRes = (LPCSTR)utf8Buf;
		free( ucBuf);
		free( utf8Buf);
	}

	//QƂu
	strReplace( strRes, "&amp;",  "&"  );
	strReplace( strRes, "&lt;",   "<"  );
	strReplace( strRes, "&gt;",   ">"  );
	strReplace( strRes, "&quot;", "\"" );
	strReplace( strRes, "&apos;", "'"  );

	//߂lƊi[
	if( iSize == 0 ){
		return strRes.length() + 1;	//Kvobt@Ԃ
	} else {
		if( int(strRes.length()+1) > iSize ) strRes = strRes.substr( 0, iSize-1 );	//wTCYȂJbg
		strcpy_s( pBuf, iSize, (LPSTR)strRes.c_str() );	//i[
		return strRes.length();
	}
}
